/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 4; tab-width: 4 -*-  */
/*
 * dessert_choice.c
 * Copyright (C) 2023 drdev <gualtieri@ieee.org>
 * 
 * dessert_choice is free software: you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * dessert_choice is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See the GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

// Reference for permutation algorithm:
// https://www.w3resource.com/c-programming-exercises/pointer/c-pointer-exercise-8.php

# define choices 5 //maximum is five
#define trials 10000

#if (choices == 3)
# define number_of_permutations (3*2*1)
#endif

#if (choices == 4)
# define number_of_permutations (4*3*2*1)
#endif

#if (choices >= 5)
# define number_of_permutations (5*4*3*2*1)
#endif

# define participants 5

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

/* Prototypes */
void srand(unsigned int seed);
int rand(void);
void exit(int status);
/* end of prototypes */

time_t t;
char fn[64] = "output.dat";
FILE *outdata;
int permutations[number_of_permutations][choices];
int selected_permutation;
char rank_choice[participants][choices];
//for satisfaction decrement = 0.80
float satisfaction_level[5]={1.0, 0.8, 0.64, 0.512, 0.4096};
float satisfaction[participants][choices];
float indexed_satisfaction[participants][256];
float total_satisfaction=0;
float max;
int i=0;
int j=0;
int k=0;
int m=0;
int n=0;

void changePosition(char *ch1, char *ch2)
{
    char tmp;
    tmp = *ch1;
    *ch1 = *ch2;
    *ch2 = tmp;
}

void charPermu(char *cht, int stno, int endno)
{
   int i;
   if (stno == endno)
   {
     //printf("%s  ", cht);
 for(k=0;k<choices;k++)
 {
	permutations[j][k] = cht[k];
  }
  j++;
   }
   else
   {
       for (i = stno; i <= endno; i++)
       {
          changePosition((cht+stno), (cht+i));
          charPermu(cht, stno+1, endno);
          changePosition((cht+stno), (cht+i)); 
       }
   }
}

int main(void)
{
	
//create datafile
	if ((outdata = fopen(fn, "w")) == NULL) {
	printf("\nOutput datafile cannot be opened.\n");
	exit(1);
    }
    
    //seed random number generator
    srand((unsigned) time(&t));
    
  char arr[5];
  arr[0] = 'a';
  arr[1] = 'b';
  arr[2] = 'c';
  arr[3] = 'd';  
  arr[4] = 'e'; 
  
   n = choices;
   arr[n]='\0';

    charPermu(arr, 0, n-1);
     
     for (j=0;j<number_of_permutations;j++)
     {
      for(k=0;k<choices;k++)
     {
	//printf("%c",permutations[j][k]);
     }
   //printf("  ");
     }
 
 for (k=0;k<trials;k++)
{
 //randomly populate rank values
for(i=0;i<participants;i++)
{
	selected_permutation = rand()%number_of_permutations;
	for (j=0;j<choices;j++)
	{
		rank_choice[i][j]=permutations[selected_permutation][j];
	}

}

//get satisfaction for rank values
for(i=0;i<participants;i++)
{
	for (j=0;j<choices;j++)
	{
       satisfaction[i][j] = satisfaction_level[rank_choice[i][j]-'a']; 
       fprintf(outdata,"%c",rank_choice[i][j]);
	}
	 fprintf(outdata,"\t");
}

//populate satisfaction array indexed by choice character
for(i=0;i<participants;i++)
{
	for (j=0;j<choices;j++)
	{
      indexed_satisfaction[i][rank_choice[i][j]]= satisfaction_level[j];
	}
}

// get optimum choice
max = 0;
	for (j=0;j<choices;j++)
	{
		total_satisfaction=0;
			for (i=0;i<participants;i++)
	          {
				  total_satisfaction=total_satisfaction+ indexed_satisfaction[i][arr[j]];
			  }
			  if (total_satisfaction>=max)
			  {
				  max = total_satisfaction;
			  }
			  
	}
		fprintf(outdata, "%1.4f\n",  max/participants);
	
}

fclose(outdata);
    return 0;
}
